Index: /boa/src/main/java/geniusweb/boa/BoaParty.java
===================================================================
--- /boa/src/main/java/geniusweb/boa/BoaParty.java	(revision 20)
+++ /boa/src/main/java/geniusweb/boa/BoaParty.java	(revision 20)
@@ -0,0 +1,137 @@
+package geniusweb.boa;
+
+import java.util.HashMap;
+
+import geniusweb.actions.Action;
+import geniusweb.boa.acceptancestrategy.AcceptanceStrategy;
+import geniusweb.boa.biddingstrategy.BiddingStrategy;
+import geniusweb.opponentmodel.OpponentModel;
+import geniusweb.party.inform.Settings;
+import tudelft.utilities.logging.Reporter;
+
+/**
+ * Determines the next {@link Action} given our profile, the opponent models,
+ * the acceptance strategy and BiddingStrategy.
+ * <p>
+ * The settings are assumed to contain parameters to set the BOA components:
+ * <ul>
+ * <li>"as" containing the full.class.path to the {@link AcceptanceStrategy}
+ * clas,
+ * <li>"os" containing the full.class.path to the   {@link OpponentModel} class
+ * <li>"bs" containing the full.class.path to the   {@link BiddingStrategy}
+ * class.
+ * <li>Other parameters as needed by the components
+ * </ul>
+ * <h1>more info</h1> For more information, see: Baarslag T., Hindriks K.V.,
+ * Hendrikx M., Dirkzwager A., Jonker C.M. Decoupling Negotiating Agents to
+ * Explore the Space of Negotiation Strategies. Proceedings of The Fifth
+ * International Workshop on Agent-based Complex Automated Negotiations (ACAN
+ * 2012), 2012.
+ * https://homepages.cwi.nl/~baarslag/pub/Decoupling_Negotiating_Agents_to_Explore_the_Space_of_Negotiation_Strategies_ACAN_2012.pdf
+ * 
+ */
+public class BoaParty extends DefaultBoa {
+	public BoaParty() {
+		super();
+	}
+
+	public BoaParty(Reporter reporter) {
+		super(reporter); // for debugging
+	}
+
+	@Override
+	public String getDescription() {
+		return "BOA party that is fully configurable through parameters. "
+				+ "Takes parameters om=OpponentModel full.class.path, "
+				+ "as=AcceptanceStrategy full.class.path "
+				+ "and bs=BiddingStrategy full.class.path. ";
+	}
+
+	/**
+	 * Overridable getter for the acceptance strategy. Override if you want to
+	 * hard code a {@link BoaParty} behaviour
+	 * 
+	 * @param settings the {@link Settings}
+	 * @return the {@link OpponentModel} class to use for modeling opponents
+	 */
+	@Override
+	protected Class<? extends OpponentModel> getOpponentModel(Settings settings)
+			throws InstantiationFailedException {
+		HashMap<String, Object> parameters = settings.getParameters();
+		return loadClass("om", OpponentModel.class, parameters);
+	}
+
+	/**
+	 * Overridable getter for the acceptance strategy. Override if you want to
+	 * hard code a {@link BoaParty} behaviour
+	 * 
+	 * @param settings the {@link Settings}
+	 * @return the {@link BiddingStrategy} to use for determining the next
+	 *         {@link Action}
+	 */
+	@Override
+	protected BiddingStrategy getBiddingStrategy(Settings settings)
+			throws InstantiationFailedException {
+		try {
+			return loadClass("bs", BiddingStrategy.class,
+					settings.getParameters()).newInstance();
+		} catch (InstantiationException | IllegalAccessException e) {
+			throw new InstantiationFailedException(
+					"Can't instantiate bidding strategy", e);
+		}
+	}
+
+	/**
+	 * Overridable getter for the acceptance strategy. Override if you want to
+	 * hard code a {@link BoaParty} behaviour
+	 * 
+	 * @param settings the {@link Settings}
+	 * @return the {@link AcceptanceStrategy} to use for determining if a bid is
+	 *         acceptable
+	 */
+	@Override
+	protected AcceptanceStrategy getAccceptanceStrategy(Settings settings)
+			throws InstantiationFailedException {
+		try {
+			return loadClass("as", AcceptanceStrategy.class,
+					settings.getParameters()).newInstance();
+		} catch (InstantiationException | IllegalAccessException e) {
+			throw new InstantiationFailedException(
+					"Can't instantiate acceptance strategy", e);
+		}
+	}
+
+	/**
+	 * 
+	 * @param <T>        the type of the class object to load
+	 * @param paramname  the name of the parameter in parameters that contains
+	 *                   the class reference, shoul dbe full.clsss.path
+	 * @param clazz      the class object to load
+	 * @param parameters the parameterlist
+	 * @return object of T, loaded from the parameter with paramname
+	 * @throws ClassNotFoundException
+	 * @throws InstantiationFailedException
+	 */
+	@SuppressWarnings("unchecked")
+	private <T> Class<T> loadClass(String paramname, Class<T> clazz,
+			HashMap<String, Object> parameters)
+			throws InstantiationFailedException {
+
+		if (!parameters.containsKey(paramname))
+			throw new InstantiationFailedException(
+					"Can not load BOA component: the parameter " + paramname
+							+ " is not specified");
+		Class<?> c;
+		try {
+			c = Class.forName((String) parameters.get(paramname));
+		} catch (ClassNotFoundException e) {
+			throw new InstantiationFailedException("Unknown BOA component", e);
+		}
+		if (!clazz.isAssignableFrom(c))
+			throw new InstantiationFailedException("Parameter " + paramname
+					+ " requires an instance of  " + clazz + ", but got " + c);
+
+		return (Class<T>) c;
+	}
+
+}
Index: /boa/src/main/java/geniusweb/boa/BoaState.java
===================================================================
--- /boa/src/main/java/geniusweb/boa/BoaState.java	(revision 20)
+++ /boa/src/main/java/geniusweb/boa/BoaState.java	(revision 20)
@@ -0,0 +1,244 @@
+package geniusweb.boa;
+
+import java.lang.reflect.Parameter;
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.PartyId;
+import geniusweb.boa.acceptancestrategy.AcceptanceStrategy;
+import geniusweb.boa.biddingstrategy.BiddingStrategy;
+import geniusweb.issuevalue.Bid;
+import geniusweb.opponentmodel.OpponentModel;
+import geniusweb.party.inform.Settings;
+import geniusweb.profile.Profile;
+import geniusweb.progress.Progress;
+import geniusweb.progress.ProgressRounds;
+import tudelft.utilities.logging.Reporter;
+
+/**
+ * Stores the current state of the negotiation for a {@link BoaParty}, including
+ * the state of the opponent models. immutable.
+ *
+ */
+public class BoaState {
+	private final Settings settings;
+	private final Profile profile;
+	private final Progress progress;
+	private final Class<? extends OpponentModel> opponentModelClass;
+	private final Map<PartyId, OpponentModel> opponentModels;
+	private final List<Action> actionHistory;
+	private final BiddingStrategy biddingStrategy;
+	private final AcceptanceStrategy acceptanceStrategy;
+	private final Reporter reporter;
+
+	/**
+	 * Initial state. Update using with(settings).
+	 */
+	public BoaState(Reporter reporter) {
+		this(null, null, null, null, null, null, Collections.emptyList(),
+				Collections.emptyMap(), reporter);
+		if (reporter == null) {
+			throw new NullPointerException("reporter must be not null");
+		}
+	}
+
+	/**
+	 * Internal constructor. Use
+	 * {@link #with(Settings, BiddingStrategy, AcceptanceStrategy, Class, Reporter)}
+	 * 
+	 * @param settings      the negoi {@link Settings}
+	 * @param profile       the {@link Profile} to be used
+	 * @param progr         the {@link Progress}
+	 * @param bidstrat      the {@link BiddingStrategy}
+	 * @param acceptstrat   the {@link AcceptanceStrategy}
+	 * @param omClass       the class of the {@link OpponentModel}
+	 * @param actionHistory list of {@link Action}s that have been done in the
+	 *                      negotiatino (by us and others), first action is the
+	 *                      oldest.
+	 * @param oppMods       a map of {@link OpponentModel}s, one for each
+	 *                      {@link PartyId} encountered in the negotiation
+	 * @param reporter      the {@link Reporter} that can be used to log
+	 *                      messages. Should equal {@link BoaParty}'s reporter
+	 */
+	private BoaState(Settings settings, Profile profile, Progress progr,
+			BiddingStrategy bidstrat, AcceptanceStrategy acceptstrat,
+			Class<? extends OpponentModel> omClass, List<Action> actionHistory,
+			Map<PartyId, OpponentModel> oppMods, Reporter reporter) {
+		this.settings = settings;
+		this.profile = profile;
+		this.progress = progr;
+		this.biddingStrategy = bidstrat;
+		this.acceptanceStrategy = acceptstrat;
+		this.opponentModelClass = omClass;
+		this.actionHistory = actionHistory;
+		this.opponentModels = oppMods;
+		this.reporter = reporter;
+	}
+
+	/**
+	 * This should be the first update call used.
+	 * 
+	 * @param settings    the negoi {@link Settings}
+	 * @param bidstrat    the {@link BiddingStrategy}
+	 * @param acceptstrat the {@link AcceptanceStrategy}
+	 * @param omClass     the class of the {@link OpponentModel}
+	 * @param reporter    the {@link Reporter} that can be used to log messages
+	 * @return initialized BoaState
+	 */
+	public BoaState with(Settings newsettings, BiddingStrategy bidstrat,
+			AcceptanceStrategy acceptstrat,
+			Class<? extends OpponentModel> omClass) {
+		if (settings != null)
+			throw new IllegalStateException("settings already set");
+		if (newsettings == null || omClass == null || bidstrat == null
+				|| acceptstrat == null || reporter == null)
+			throw new NullPointerException(
+					"settings, reporter, bidstrat, acceptstrat, omClass and oModels must be not null");
+		return new BoaState(newsettings, null, newsettings.getProgress(),
+				bidstrat, acceptstrat, omClass, actionHistory,
+				new HashMap<PartyId, OpponentModel>(), reporter);
+	}
+
+	public BoaState with(Profile newprofile) {
+		return new BoaState(settings, newprofile, progress, biddingStrategy,
+				acceptanceStrategy, opponentModelClass, actionHistory,
+				opponentModels, reporter);
+
+	}
+
+	/**
+	 * 
+	 * @return the settings for this negotiation, includes my {@link PartyId},
+	 *         {@link Parameter}, {@link Profile} etc.
+	 */
+	public Settings getSettings() {
+		return settings;
+	}
+
+	/**
+	 * 
+	 * @return the {@link Profile} as fetched from the profiles server, or null
+	 *         if no profile was received yet.
+	 */
+	public Profile getProfile() {
+		return profile;
+	}
+
+	/**
+	 * 
+	 * @param action the action that was done by some participant (possibly us).
+	 * @return new BoaState that includes action.getBid as last bid (if action
+	 *         contains a bid), and with updated opponentmodel of that
+	 *         participant.
+	 * @throws InstantiationFailedException if one of provided classes can not
+	 *                                      be instantiated.
+	 */
+	public BoaState with(Action action) throws InstantiationFailedException {
+		List<Action> newactions = new ArrayList<Action>(actionHistory);
+		newactions.add(action);
+		Progress newprogress = progress;
+		Map<PartyId, OpponentModel> newmodels = opponentModels;
+
+		if (action.getActor().equals(settings.getID())) {
+			// ourside, just advance progress
+			if (progress instanceof ProgressRounds) {
+				// bit hacky, maybe we should wait
+				newprogress = ((ProgressRounds) progress).advance();
+			}
+		} else {
+			// not ourselves, update the OpponentModel
+			newmodels = updateModels(action);
+		}
+		return new BoaState(settings, profile, newprogress, biddingStrategy,
+				acceptanceStrategy, opponentModelClass, newactions, newmodels,
+				reporter);
+	}
+
+	/**
+	 * @return the current {@link Progress}
+	 */
+	public Progress getProgress() {
+		return progress;
+	}
+
+	/**
+	 * @return list of actions done so far, oldest action first
+	 */
+	public List<Action> getActionHistory() {
+		return Collections.unmodifiableList(actionHistory);
+	}
+
+	/**
+	 * 
+	 * @param bid
+	 * @return true iff {@link #acceptanceStrategy} says the bid is acceptable
+	 */
+	public boolean isAcceptable(Bid bid) {
+		return acceptanceStrategy.isAcceptable(bid, this);
+	}
+
+	/**
+	 * 
+	 * @return the next recommended action according to the
+	 *         {@link #biddingStrategy}
+	 */
+	public Action getAction() {
+		return biddingStrategy.getAction(this);
+	}
+
+	/**
+	 * 
+	 * @return the Reporter (same as the BoaParty's reporter)
+	 */
+	public Reporter getReporter() {
+		return reporter;
+	}
+
+	/**
+	 * @param action
+	 * @return the map with the opponentmodels, with the model for the party
+	 *         that did the action updated.
+	 * @throws InstantiationFailedException
+	 */
+	private Map<PartyId, OpponentModel> updateModels(Action action)
+			throws InstantiationFailedException {
+		PartyId actor = action.getActor();
+		Map<PartyId, OpponentModel> updated = extendedOpponentModels(actor);
+		updated.put(actor, updated.get(actor).with(action, progress));
+		return updated;
+	}
+
+	/**
+	 * Get the current opponent model, extended with newparty if there is no
+	 * model yet for newparty.
+	 * 
+	 * @param newparty a possibly new party
+	 * @return a (possibly new) opponentModels map
+	 * @throws InstantiationException
+	 * @throws IllegalAccessException
+	 * @throws InstantiationFailedException
+	 */
+	private Map<PartyId, OpponentModel> extendedOpponentModels(PartyId newparty)
+			throws InstantiationFailedException {
+		// check if this is new party
+		if (opponentModels.containsKey(newparty))
+			return opponentModels;
+
+		Map<PartyId, OpponentModel> newmodels = new HashMap<>(opponentModels);
+		OpponentModel newmodel;
+		try {
+			newmodel = opponentModelClass.newInstance()
+					.with(profile.getDomain(), profile.getReservationBid());
+		} catch (Exception e) {
+			throw new InstantiationFailedException(
+					"Failed to instantiate " + opponentModelClass, e);
+		}
+		newmodels.put(newparty, newmodel);
+		return newmodels;
+	}
+
+}
Index: /boa/src/main/java/geniusweb/boa/DefaultBoa.java
===================================================================
--- /boa/src/main/java/geniusweb/boa/DefaultBoa.java	(revision 20)
+++ /boa/src/main/java/geniusweb/boa/DefaultBoa.java	(revision 20)
@@ -0,0 +1,166 @@
+package geniusweb.boa;
+
+import java.util.Arrays;
+import java.util.HashSet;
+import java.util.List;
+import java.util.logging.Level;
+
+import geniusweb.actions.Accept;
+import geniusweb.actions.Action;
+import geniusweb.actions.Offer;
+import geniusweb.boa.acceptancestrategy.AcceptanceStrategy;
+import geniusweb.boa.biddingstrategy.BiddingStrategy;
+import geniusweb.issuevalue.Bid;
+import geniusweb.opponentmodel.OpponentModel;
+import geniusweb.party.Capabilities;
+import geniusweb.party.DefaultParty;
+import geniusweb.party.inform.ActionDone;
+import geniusweb.party.inform.Finished;
+import geniusweb.party.inform.Inform;
+import geniusweb.party.inform.Settings;
+import geniusweb.party.inform.YourTurn;
+import geniusweb.profileconnection.ProfileConnectionFactory;
+import geniusweb.profileconnection.ProfileInterface;
+import tudelft.utilities.logging.Reporter;
+
+/**
+ * Default behaviour for Boa-style parties
+ */
+public abstract class DefaultBoa extends DefaultParty {
+
+	private BoaState negoState;
+	private ProfileInterface profileint = null;
+
+	public DefaultBoa() {
+		super();
+		negoState = initialState();
+	}
+
+	public DefaultBoa(Reporter reporter) {
+		super(reporter); // for debugging
+		negoState = initialState();
+	}
+
+	/**
+	 * This only supports SAOP protocol because it is not clear how the
+	 * BiddingStrategy could be made more general without basically becoming a
+	 * full Party.
+	 * 
+	 */
+	@Override
+	public Capabilities getCapabilities() {
+		/*
+		 * At this moment only SAOP is supported by BOA. To support others, the
+		 * components also need to get capabilities
+		 */
+		return new Capabilities(new HashSet<>(Arrays.asList("SAOP")));
+	}
+
+	/**
+	 * Impementation of generic BOA behaviour.
+	 */
+	@Override
+	public void notifyChange(Inform info) {
+		try {
+			if (info instanceof Settings) {
+				/*
+				 * this should be first call. We can not yet create the state
+				 * because we need to wait for the profile fetch.
+				 */
+				Settings settings = (Settings) info;
+				Class<? extends OpponentModel> omClass = getOpponentModel(
+						settings);
+				BiddingStrategy bidStrat = getBiddingStrategy(settings);
+				AcceptanceStrategy acceptStrat = getAccceptanceStrategy(
+						settings);
+				negoState = negoState.with(settings, bidStrat, acceptStrat,
+						omClass);
+				this.profileint = ProfileConnectionFactory
+						.create(settings.getProfile().getURI(), getReporter());
+				return;
+			}
+
+			// Beyond this point we should have a profile
+			if (negoState.getProfile() == null) {
+				negoState = negoState.with(this.profileint.getProfile());
+			}
+
+			if (info instanceof ActionDone) {
+				negoState = negoState.with(((ActionDone) info).getAction());
+			} else if (info instanceof YourTurn) {
+				getConnection().send(getAction());
+				// we will receive ActionDone and update state then
+			} else if (info instanceof Finished) {
+				getReporter().log(Level.INFO, "Final ourcome:" + info);
+			}
+		} catch (Exception e) {
+			throw new RuntimeException("Failed to handle info " + info, e);
+		}
+
+	}
+
+	/**
+	 * Overridable getter for the acceptance strategy. Override if you want to
+	 * hard code a {@link BoaParty} behaviour
+	 * 
+	 * @param settings the {@link Settings}
+	 * @return the {@link OpponentModel} class to use for modeling opponents
+	 */
+	abstract protected Class<? extends OpponentModel> getOpponentModel(
+			Settings settings) throws InstantiationFailedException;
+
+	/**
+	 * Overridable getter for the acceptance strategy. Override if you want to
+	 * hard code a {@link BoaParty} behaviour
+	 * 
+	 * @param settings the {@link Settings}
+	 * @return the {@link BiddingStrategy} to use for determining the next
+	 *         {@link Action}
+	 */
+	abstract protected BiddingStrategy getBiddingStrategy(Settings settings)
+			throws InstantiationFailedException;
+
+	/**
+	 * Overridable getter for the acceptance strategy. Override if you want to
+	 * hard code a {@link BoaParty} behaviour
+	 * 
+	 * @param settings the {@link Settings}
+	 * @return the {@link AcceptanceStrategy} to use for determining if a bid is
+	 *         acceptable
+	 */
+	abstract protected AcceptanceStrategy getAccceptanceStrategy(
+			Settings settings) throws InstantiationFailedException;
+
+	/**
+	 * Factory method to create initial state. Override to insert mock
+	 * 
+	 * @return initial BoaState
+	 */
+	protected BoaState initialState() {
+		return new BoaState(getReporter());
+	}
+
+	/**
+	 * @return the most recent bid that was offered, or null if no offer has
+	 *         been done yet.
+	 */
+	protected Bid getLastBid() {
+		List<Action> actions = negoState.getActionHistory();
+		for (int n = actions.size() - 1; n >= 0; n--) {
+			Action action = actions.get(n);
+			if (action instanceof Offer) {
+				return ((Offer) action).getBid();
+			}
+		}
+		return null;
+	}
+
+	private Action getAction() {
+		Bid lastBid = getLastBid();
+		if (lastBid != null && negoState.isAcceptable(lastBid)) {
+			return new Accept(negoState.getSettings().getID(), lastBid);
+		}
+		return negoState.getAction();
+	}
+
+}
Index: /boa/src/main/java/geniusweb/boa/InstantiationFailedException.java
===================================================================
--- /boa/src/main/java/geniusweb/boa/InstantiationFailedException.java	(revision 20)
+++ /boa/src/main/java/geniusweb/boa/InstantiationFailedException.java	(revision 20)
@@ -0,0 +1,19 @@
+package geniusweb.boa;
+
+/**
+ * Failed to create instance of some class
+ *
+ */
+public class InstantiationFailedException extends Exception {
+
+	private static final long serialVersionUID = -3368583000286378339L;
+
+	public InstantiationFailedException(String string) {
+		super(string);
+	}
+
+	public InstantiationFailedException(String string, Throwable e) {
+		super(string, e);
+	}
+
+}
Index: /boa/src/main/java/geniusweb/boa/acceptancestrategy/AcceptanceStrategy.java
===================================================================
--- /boa/src/main/java/geniusweb/boa/acceptancestrategy/AcceptanceStrategy.java	(revision 20)
+++ /boa/src/main/java/geniusweb/boa/acceptancestrategy/AcceptanceStrategy.java	(revision 20)
@@ -0,0 +1,34 @@
+package geniusweb.boa.acceptancestrategy;
+
+import geniusweb.boa.BoaParty;
+import geniusweb.boa.BoaState;
+import geniusweb.issuevalue.Bid;
+import geniusweb.party.inform.Settings;
+
+/**
+ * Determines in which states a bid is acceptable. Typically used as one of the
+ * components of a {@link BoaParty}
+ * <p>
+ * <em>MUST</em> have an empty constructor.
+ */
+public interface AcceptanceStrategy {
+
+	/**
+	 * determine acceptability of a bid.
+	 * <p>
+	 * <b>Note</b> for implementors: The AcceptanceStrategy can extract
+	 * configuration parameters from {@link Settings#getParameters} using
+	 * {@link BoaState#getSettings()}. Generally we recommend to write
+	 * implementations such that they can also be hard-configured, for easier
+	 * use of the components in hard-coded settings.
+	 * 
+	 * @param bid       the bid to be checked
+	 * @param negoState the current {@link BoaState}.
+	 * 
+	 * 
+	 * @return true iff current bid is acceptable at this moment. Notice that in
+	 *         theory a protocol might allow accepting other bids than the
+	 *         latest. But at this moment only SAOP is supported by BOA.
+	 */
+	Boolean isAcceptable(Bid bid, BoaState negoState);
+}
Index: /boa/src/main/java/geniusweb/boa/acceptancestrategy/TimeDependentAcceptanceStrategy.java
===================================================================
--- /boa/src/main/java/geniusweb/boa/acceptancestrategy/TimeDependentAcceptanceStrategy.java	(revision 20)
+++ /boa/src/main/java/geniusweb/boa/acceptancestrategy/TimeDependentAcceptanceStrategy.java	(revision 20)
@@ -0,0 +1,166 @@
+package geniusweb.boa.acceptancestrategy;
+
+import java.util.HashMap;
+
+import geniusweb.bidspace.BidsWithUtility;
+import geniusweb.boa.BoaState;
+import geniusweb.boa.biddingstrategy.TimeDependentBiddingStrategy;
+import geniusweb.issuevalue.Bid;
+import geniusweb.party.inform.Settings;
+import geniusweb.profile.Profile;
+import geniusweb.profile.utilityspace.LinearAdditive;
+import geniusweb.profile.utilityspace.UtilitySpace;
+
+/**
+ * Simple implementation similar to the {@link TimeDependentBiddingStrategy}.
+ * Uses 4 parameters:
+ * <ul>
+ * <li>e: the exponent for the target-utility function. See {@link #f(double)}
+ * <li>k: the constant for the target-utility function. See {@link #f(double)}
+ * <li>max: the maximum utility target used at t=0.
+ * <li>min: the minimum utility target used at t=1
+ * </ul>
+ */
+public class TimeDependentAcceptanceStrategy implements AcceptanceStrategy {
+
+	private Double min = null, max = null, e = null, k = null;
+
+	@Override
+	public Boolean isAcceptable(Bid bid, BoaState state) {
+		if (min == null || max == null || e == null || k == null) {
+			min = getMin(state);
+			max = getMax(state);
+			e = getE(state);
+			k = getK(state);
+		}
+		double targetUtil = p(
+				state.getProgress().get(System.currentTimeMillis()));
+		// we subtract epsilon because of rounding errors in computation.
+		return ((UtilitySpace) state.getProfile()).getUtility(bid)
+				.doubleValue() >= targetUtil - 0.0000001;
+	}
+
+	/**
+	 * Overrideable for hard configuring this component.
+	 * 
+	 * @param state the {@link BoaState}
+	 * @return the parameter e for the time depemdency function
+	 *         {@link #f(double)}. The parameter is 1 by default, or the value
+	 *         for the "e" parameter in the {@link Settings} if available.
+	 */
+	protected Double getE(BoaState state) {
+		HashMap<String, Object> params = state.getSettings().getParameters();
+		Double e = 1d;
+		if (params.containsKey("e")) {
+			e = (Double) params.get("e");
+			if (e < 0 || e > 1)
+				throw new IllegalArgumentException(
+						"e must be in [0,1] but got " + this.e);
+		}
+		return e;
+	}
+
+	/**
+	 * Overrideable for hard configuring this component.
+	 * 
+	 * @param state the {@link BoaState}
+	 * @return the parameter k for the time depemdency function
+	 *         {@link #f(double)}. The parameter is 0 by default, or the value
+	 *         for the "k" parameter in the {@link Settings} if available.
+	 */
+	protected Double getK(BoaState state) {
+		HashMap<String, Object> params = state.getSettings().getParameters();
+		Double k = 0d; // default
+		if (params.containsKey("k")) {
+			k = (Double) params.get("k");
+			if (k < 0 || k > 1)
+				throw new IllegalArgumentException(
+						"k must be in [0,1] but got " + this.e);
+		}
+		return k;
+	}
+
+	/**
+	 * Overrideable for hard configuring this component.
+	 * 
+	 * @param state the {@link BoaState}
+	 * @return the min value for {@link #p(double)}. We use the "min" parameter
+	 *         in the {@link Settings} if available. If not available, the
+	 *         parameter is computed as the utility of the reservation bid. If
+	 *         there is no reservation bid, we use the minimum utility of the
+	 *         available profile.
+	 */
+	protected Double getMin(BoaState state) {
+		HashMap<String, Object> params = state.getSettings().getParameters();
+		if (params.containsKey("min")) {
+			return Math.max(0f, Math.min(1f, (Double) params.get("min")));
+		}
+		UtilitySpace profile = (UtilitySpace) state.getProfile();
+		if (profile.getReservationBid() != null) {
+			return profile.getUtility(profile.getReservationBid())
+					.doubleValue();
+		}
+
+		return getBidspace(profile).getRange().getMin().doubleValue();
+	}
+
+	/**
+	 * Overrideable for hard configuring this component.
+	 * 
+	 * @param state the {@link BoaState}
+	 * @return the max value for {@link #p(double)}. We use the "max" parameter
+	 *         in the {@link Settings} if available. If not available, we use
+	 *         the maximum utility of the available profile.
+	 */
+	protected Double getMax(BoaState state) {
+		HashMap<String, Object> params = state.getSettings().getParameters();
+		if (params.containsKey("max")) {
+			return Math.max(0f, Math.min(1f, (Double) params.get("max")));
+		}
+		UtilitySpace profile = (UtilitySpace) state.getProfile();
+		return getBidspace(profile).getRange().getMax().doubleValue();
+
+	}
+
+	/**
+	 * factory method. Overridable for testing
+	 * 
+	 * @param profile the profile to get a bidspace for
+	 * @return {@link BidsWithUtility}
+	 */
+	protected BidsWithUtility getBidspace(Profile profile) {
+		return new BidsWithUtility((LinearAdditive) profile);
+	}
+
+	/**
+	 * Makes sure the target utility with in the acceptable range according to
+	 * the domain
+	 * 
+	 * @param t the normalized current time in the negotiation, where t=9 at
+	 *          start of negotiation and t=1 at end of negotiation.
+	 * @return double
+	 */
+	private double p(double t) {
+		return this.min + (this.max - this.min) * (1.0 - f(t));
+	}
+
+	/**
+	 * From the paper:
+	 * 
+	 * A wide range of time dependent functions can be defined by varying the
+	 * way in which f(t) is computed. However, functions must ensure that 0 <=
+	 * f(t) <= 1, f(0) = k, and f(1) = 1.
+	 * 
+	 * That is, the offer will always be between the value range, at the
+	 * beginning it will give the initial constant and when the deadline is
+	 * reached, it will offer the reservation value.
+	 * 
+	 * @param t the normalized current time in the negotiation, where t=9 at
+	 *          start of negotiation and t=1 at end of negotiation.
+	 * @return
+	 */
+	private double f(double t) {
+		return k + (1.0 - k) * Math.pow(t, 1.0 / e);
+	}
+
+}
Index: /boa/src/main/java/geniusweb/boa/biddingstrategy/BiddingStrategy.java
===================================================================
--- /boa/src/main/java/geniusweb/boa/biddingstrategy/BiddingStrategy.java	(revision 20)
+++ /boa/src/main/java/geniusweb/boa/biddingstrategy/BiddingStrategy.java	(revision 20)
@@ -0,0 +1,34 @@
+package geniusweb.boa.biddingstrategy;
+
+import geniusweb.actions.Action;
+import geniusweb.boa.BoaParty;
+import geniusweb.boa.BoaState;
+import geniusweb.party.inform.Settings;
+
+/**
+ * Determines what action to take in which state.
+ * <p>
+ * Assumed part of a {@link BoaParty}.
+ * 
+ * <p>
+ * <em>MUST</em> have an empty constructor.
+ */
+public interface BiddingStrategy {
+
+	/**
+	 * Recommend a next action.
+	 * <p>
+	 * <b>Note</b> for implementors: This can extract configuration parameters
+	 * from {@link Settings#getParameters} using {@link BoaState#getSettings()}.
+	 * Generally we recommend to write implementations such that they can also
+	 * be hard-configured, for easier use of the components in hard-coded
+	 * settings.
+	 * 
+	 * @param state the current {@link BoaState}
+	 * 
+	 * @return the suggested next Action. Should always return a valid action,
+	 *         not null.
+	 */
+	Action getAction(BoaState state);
+
+}
